//
// Created by nicolas on 22/03/18.
//

#ifndef ESC_ESC_CONNECTION_H
#define ESC_ESC_CONNECTION_H

#include <protobuf-c/protobuf-c.h>
#include "endpoint_discoverer.h"
#include "tcp_package.h"
#include "utils/bool.h"
#include "utils/socket.h"
#include "utils/thread.h"
#include "utils/mutex.h"
#include "utils/queue.h"
#include "utils/error.h"
#include "utils/event.h"

typedef struct st_esc_connection_settings {
    bool_t use_ssl_connection;
} esc_connection_settings_t;

esc_connection_settings_t* esc_default_connection_settings;

typedef struct st_esc_connection {
    esc_connection_settings_t* settings;
    const char* name;
    void* discoverer_data;
    esc_endpoint_discoverer_t discover;
    socket_t* tcp_conn;
    thread_t* manager_thread;
    bool_t stop;
    queue_t* send_queue;
    queue_t* recv_queue;
    error_t* last_error;
    event_t* stopped_event;
    queue_t* subscriptions;
} esc_connection_t;

tcp_package_t* connection_wait_for(esc_connection_t* conn, uuid_t* correlation_id);
error_t* esc_connection_last_error(esc_connection_t* conn);
void esc_connection_close(esc_connection_t* conn);

#endif //ESC_ESC_CONNECTION_H
